using System.Text.Json;
using System.Text.Json.Serialization;

namespace EDAViewer.Models;

public class AppSettings
{

    protected string _BuildNumber;
    protected string _Company;
    protected string _ECEDADatabasePassword;
    protected string _GitCommitSeven;
    protected string _IFXEDADatabasePassword;
    protected string _MonARessource;
    protected string _Server;
    protected string _URLs;
    protected string _WorkingDirectoryName;
    public string BuildNumber => _BuildNumber;
    public string Company => _Company;
    public string ECEDADatabasePassword => _ECEDADatabasePassword;
    public string GitCommitSeven => _GitCommitSeven;
    public string IFXEDADatabasePassword => _IFXEDADatabasePassword;
    public string MonARessource => _MonARessource;
    public string Server => _Server;
    public string URLs => _URLs;
    public string WorkingDirectoryName => _WorkingDirectoryName;

    // public AppSettings()
    // {
    // }

    [JsonConstructor]
    public AppSettings(string buildNumber, string company, string ecEDADatabasePassword, string gitCommitSeven, string ifxEDADatabasePassword, string monARessource, string server, string urls, string workingDirectoryName)
    {
        _BuildNumber = buildNumber;
        _Company = company;
        _ECEDADatabasePassword = ecEDADatabasePassword;
        _GitCommitSeven = gitCommitSeven;
        _IFXEDADatabasePassword = ifxEDADatabasePassword;
        _MonARessource = monARessource;
        _Server = server;
        _URLs = urls;
        _WorkingDirectoryName = workingDirectoryName;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}