using System.ComponentModel.DataAnnotations;
using System.Text.Json;

namespace EDAViewer.Models.Binder;

public class AppSettings
{

    [Display(Name = "Build Number"), Required] public string BuildNumber { get; set; }
    [Display(Name = "Company"), Required] public string Company { get; set; }
    [Display(Name = "EC EDA Database Password"), Required] public string ECEDADatabasePassword { get; set; }
    [Display(Name = "Git Commit Seven"), Required] public string GitCommitSeven { get; set; }
    [Display(Name = "IFX EDA Database Password"), Required] public string IFXEDADatabasePassword { get; set; }
    [Display(Name = "MonA Ressource"), Required] public string MonARessource { get; set; }
    [Display(Name = "Server"), Required] public string Server { get; set; }
    [Display(Name = "URLs"), Required] public string URLs { get; set; }
    [Display(Name = "Working Directory Name"), Required] public string WorkingDirectoryName { get; set; }

    public AppSettings()
    {
        BuildNumber = string.Empty;
        Company = string.Empty;
        ECEDADatabasePassword = string.Empty;
        GitCommitSeven = string.Empty;
        IFXEDADatabasePassword = string.Empty;
        MonARessource = string.Empty;
        Server = string.Empty;
        URLs = string.Empty;
        WorkingDirectoryName = string.Empty;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}